package com.company.specifinheritance.screen.itemslist;

import com.company.specifinheritance.entity.Item;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.model.InstanceContainer;
import io.jmix.ui.screen.*;
import com.company.specifinheritance.entity.ItemsList;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ItemsList.browse")
@UiDescriptor("items-list-browse.xml")
@LookupComponent("itemsListsTable")
public class ItemsListBrowse extends StandardLookup<ItemsList> {
    @Autowired
    private CollectionLoader<Item> itemsDl;

    @Subscribe(id = "itemsListsDc", target = Target.DATA_CONTAINER)
    public void onItemsListsDcItemChange(InstanceContainer.ItemChangeEvent<ItemsList> event) {
        ItemsList entity = event.getItem();
        if (entity == null) {
            itemsDl.setParameter("itemsList", null);
        } else {
            itemsDl.setParameter("itemsList", entity.getId());
        }
        itemsDl.load();
    }
}